use $(DatabaseName);
GO

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'secRMMSQLTableValuedFunction')
   DROP FUNCTION secRMMSQLTableValuedFunction;
GO

IF EXISTS (SELECT name FROM sys.assemblies WHERE name = 'secRMMSQLTableValuedFunction')
   DROP ASSEMBLY secRMMSQLTableValuedFunction; 
GO

PRINT N'AssemblyFile1=' + '$(AssemblyFileName1)';

CREATE ASSEMBLY secRMMSQLTableValuedFunction 
FROM '$(AssemblyFileName1)'
WITH PERMISSION_SET = SAFE;

IF @@ERROR = 0 
    BEGIN
        PRINT N'CREATE ASSEMBLY1 SUCCEEDED.';
    END
ELSE
    BEGIN
        PRINT N'An error occurred at CREATE ASSEMBLY1.';
    END;

GO

CREATE FUNCTION secRMMSQLTableValuedFunction(@stringDatabaseName_in nvarchar(100),
											 @boolConvertDateTimeToLocal_in bit)
RETURNS TABLE (
	EventId int,
	Event nvarchar(64),
	Time datetime,
	Computer nvarchar(448),
	UserName nvarchar(448),
	UserSID nvarchar(448),
	Drive nvarchar(448),
	Volume nvarchar(448),
	DeviceDescription nvarchar(448),
	SerialNumber nvarchar(448),
	Model nvarchar(448),
	InternalID nvarchar(448),
	TargetFile nvarchar(448),
	SourceFile nvarchar(448),
	SourceFileSize nvarchar(448),
	SourceFileLastWrite nvarchar(448),
	ProgramName nvarchar(448),
	ProgramPID nvarchar(448),
	Message nvarchar(4000),
	PropertyName nvarchar(448),
	PropertyAction nvarchar(448),
	PropertyValue nvarchar(448),
	PreviousPropertyValue nvarchar(448),
	PropertyTarget nvarchar(448),
	PropertyOperationStatus nvarchar(448),
	AdditionalProgramInfo nvarchar(4000)
)
AS EXTERNAL NAME secRMMSQLTableValuedFunction.secRMMSQLTableValuedFunction.[InitMethod];

GO

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'CompareUserLists')
   DROP FUNCTION CompareUserLists
GO

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'secRMMSQLScalarValuedFunction')
   DROP FUNCTION secRMMSQLScalarValuedFunction;
GO

IF EXISTS (SELECT name FROM sys.assemblies WHERE name = 'secRMMSQLScalarValuedFunction')
   DROP ASSEMBLY secRMMSQLScalarValuedFunction; 
GO

PRINT N'AssemblyFile2=' + '$(AssemblyFileName2)';

CREATE ASSEMBLY secRMMSQLScalarValuedFunction 
FROM '$(AssemblyFileName2)'
WITH PERMISSION_SET = SAFE;

IF @@ERROR = 0 
    BEGIN
        PRINT N'CREATE ASSEMBLY2 SUCCEEDED.';
    END
ELSE
    BEGIN
        PRINT N'An error occurred at CREATE ASSEMBLY2.';
    END;

GO

CREATE FUNCTION [dbo].[CompareUserLists](@stringList1_in [nvarchar](max), @stringList2_in [nvarchar](max))
RETURNS [bit] WITH EXECUTE AS CALLER
AS 
EXTERNAL NAME [secRMMSQLScalarValuedFunction].[secRMMSQLScalarValuedFunctions.secRMMSQLScalarValuedFunction].[CompareUserLists]

GO

--GRANT SELECT ON [dbo].[secRMMSQLTableValuedFunction] TO [smsschm_users]
--GRANT EXECUTE ON [dbo].[CompareUserLists] TO [smsschm_users]

--SCCM
--GRANT SELECT ON [dbo].[vStatusMessageInsStrs] TO [smsschm_users]
--GRANT SELECT ON [dbo].[vStatusMessages] TO [smsschm_users]

--Standalone
--GRANT SELECT ON [dbo].[secRMMTable] TO [domain\userOrgroup]

--GO

sp_configure 'clr enabled', 1

RECONFIGURE